local ctm = CreateFrame("Frame", "ctm");

ctm:RegisterEvent("MODIFIER_STATE_CHANGED");
ctm:RegisterEvent("PLAYER_ENTERING_WORLD");

SetCVar("AutoInteract",0)

ctm:SetScript("OnEvent", 
  function(self, event, ...) 
    if self[event] then
      self[event](...)
    end
end)

local function RequiredMods()
	local requiredMods = "|cffff0000"
	local modsCounted = CTMDB.alt+CTMDB.shift+CTMDB.control
	if modsCounted == 0 then
		requiredMods = requiredMods.."no modifiers"
	end
	if CTMDB.shift == 1 then
		requiredMods = requiredMods.."shift"
		modsCounted = modsCounted - 1
		if modsCounted > 0 then requiredMods = requiredMods.."+" end
	end
	if CTMDB.control == 1 then
		requiredMods = requiredMods.."control"
		modsCounted = modsCounted - 1
		if modsCounted > 0 then requiredMods = requiredMods.."+" end		
	end
	if CTMDB.alt == 1 then
		requiredMods = requiredMods.."alt"
		modsCounted = modsCounted - 1
		if modsCounted > 0 then requiredMods = requiredMods.."+" end		
	end
	requiredMods = requiredMods.."|cffffffff"
	return requiredMods
end

function ctm.PLAYER_ENTERING_WORLD(self,event,...)

	local defaults = {
		shift = 0,
		control = 0,
		alt = 1,
		combat = true,
		explicit = false,
	}
	
	CTMDB = CTMDB or {}
	
	for key, value in pairs(defaults) do
		if( CTMDB[key] == nil ) then
			CTMDB[key] = value
		end
	end

	print("|cffff0000CTM|cffffffff: currently requires: "..RequiredMods()..", combat lockdown is |cffff0000"..(CTMDB.combat == true and "enabled" or "disabled").."|cffffffff, explicit modifiers is |cffff0000"..(CTMDB.explicit == true and "enabled" or "disabled"))
	ctm:UnregisterEvent("PLAYER_ENTERING_WORLD")	
end

function ctm.MODIFIER_STATE_CHANGED(self,event,...)
	local modCount = CTMDB.alt+CTMDB.shift+CTMDB.control
	--print(modCount)
	local modsHeld = 0
	local modsTotal = 0
	-- if IsAltKeyDown() and CTMDB.alt == 1 then
		-- modsHeld = modsHeld + 1
	-- end
	-- if IsShiftKeyDown() and CTMDB.shift == 1 then
		-- modsHeld = modsHeld + 1
	-- end
	-- if IsControlKeyDown() and CTMDB.control == 1 then
		-- modsHeld = modsHeld + 1
	-- end
		
	if IsAltKeyDown() then
		if CTMDB.alt == 1 then
			modsHeld = modsHeld + 1
		end
		modsTotal = modsTotal + 1
	end
	if IsShiftKeyDown() then
		if CTMDB.shift == 1 then
			modsHeld = modsHeld + 1
		end
		modsTotal = modsTotal + 1
	end	
	if IsControlKeyDown() then
		if CTMDB.shift == 1 then
			modsHeld = modsHeld + 1
		end
		modsTotal = modsTotal + 1
	end	
	
	-- if CTMDB.combat then
		-- if not InCombatLockdown() and modsHeld == modCount then
			-- SetCVar("AutoInteract",1)
		-- else
			-- SetCVar("AutoInteract",0)
		-- end
	-- elseif modsHeld == modCount then
		-- SetCVar("AutoInteract",1)
	-- else
		-- SetCVar("AutoInteract",0)
	-- end
	--print("modsHeld "..modsHeld.." modCount "..modCount.." modsTotal "..modsTotal)
	if (CTMDB.combat and not InCombatLockdown() or not CTMDB.combat) and (CTMDB.explicit and modsHeld == modsTotal or not CTMDB.explicit) and modsHeld == modCount then
		SetCVar("AutoInteract",1)
	else
		SetCVar("AutoInteract",0)
	end	
	
	--print("CTM set to "..GetCVar("AutoInteract"))
end

SLASH_CTM1 = "/ctm"
SLASH_CTM2 = "/clicktomove"

SlashCmdList["CTM"] = function(msg)
	if msg == "shift" then
		if CTMDB.shift == 0 then
			print("|cffff0000CTM|cffffffff: Shift now required")
			CTMDB.shift = 1
		else
			print("|cffff0000CTM|cffffffff: Shift no longer required")
			CTMDB.shift = 0
		end
	elseif msg == "control" then
		if CTMDB.control == 0 then
			print("|cffff0000CTM|cffffffff: Control now required")
			CTMDB.control = 1
		else
			print("|cffff0000CTM|cffffffff: Control no longer required")
			CTMDB.control = 0
		end
	elseif msg == "alt" then
		if CTMDB.alt == 0 then
			print("|cffff0000CTM|cffffffff: Alt now required")
			CTMDB.alt = 1
		else
			print("|cffff0000CTM|cffffffff: Alt no longer required")
			CTMDB.alt = 0
		end
	elseif msg == "combat" then
		if CTMDB.combat == false then
			print("|cffff0000CTM|cffffffff: Combat lockdown now enabled")
			CTMDB.combat = true
		else
			print("|cffff0000CTM|cffffffff: Combat lockdown now disabled")
			CTMDB.combat = false
		end
	elseif msg == "explicit" then
		if CTMDB.explicit == false then
			print("|cffff0000CTM|cffffffff: Explicit modifiers now enabled")
			CTMDB.explicit = true
		else
			print("|cffff0000CTM|cffffffff: Explicit modifiers now disabled")
			CTMDB.explicit = false
		end
	else
		print("|cffff0000ClickToMove|cffffffff commands:")
		print("|cffff0000/ctm shift/alt/control :|cffffffff Require this key to be held. Only one can be changed at a time")
		print("|cffff0000/ctm combat :|cffffffff Enable or disable combat lockout")
		print("|cffff0000/ctm explicit :|cffffffff Require exact modifiers")
	end
	print("|cffff0000CTM|cffffffff: currently requires: "..RequiredMods()..", combat lockdown is |cffff0000"..(CTMDB.combat == true and "enabled" or "disabled").."|cffffffff, explicit modifiers is |cffff0000"..(CTMDB.explicit == true and "enabled" or "disabled"))
end

hooksecurefunc("CameraOrSelectOrMoveStart",ctm.MODIFIER_STATE_CHANGED)
hooksecurefunc("TurnOrActionStart",ctm.MODIFIER_STATE_CHANGED)
